All patches and comments are welcome. Please squash your changes to logical
commits before using git-format-patch and git-send-email to
patches@git.madduck.net.
If you'd read over the Git project's submission guidelines and adhered to them,
I'd be especially grateful.
3 # This program is licensed under the GNU GPL version 2 or later.
4 # (c) Richard "RichiH" Hartmann <richih.mailinglist@gmail.com>, 2011-2013
5 # For details, see LICENSE. To submit patches, you have to agree to
6 # license your code under the GNU GPL version 2 or later.
8 # While the following is not legally binding, the author would like to
9 # explain the choice of GPLv2+ over GPLv3+.
10 # The author prefers GPLv3+ over GPLv2+ but feels it's better to maintain
11 # full compatibility's with git. In case git ever changes its licensing terms,
12 # which is admittedly extremely unlikely to the point of being impossible,
13 # this software will most likely follow suit.
15 # This should always be the first line of code to facilitate debugging
16 [ -n "$VCSH_DEBUG" ] && set -vx
19 # Implemented in shell to avoid spawning another process
22 [ -z "$2" ] || file="${file%$2}"
30 echo "$SELF: fatal: $1" >&2
34 # We need to run getops as soon as possible so we catch -d and other
35 # options that will modify our behaviour.
36 # Commands are handled at the end of this script.
37 while getopts "c:dv" flag; do
38 if [ "$1" = '-d' ] || [ "$1" = '--debug' ]; then
42 elif [ "$1" = '-v' ];then
45 elif [ "$1" = '-c' ];then
46 VCSH_OPTION_CONFIG=$OPTARG
52 # Source file even if it's in $PWD and does not have any slashes in it
60 # Read configuration and set defaults if anything's not set
61 [ -n "$VCSH_DEBUG" ] && set -vx
62 [ -z "$XDG_CONFIG_HOME" ] && XDG_CONFIG_HOME="$HOME/.config"
64 # Read configuration files if there are any
65 [ -r "/etc/vcsh/config" ] && . "/etc/vcsh/config"
66 [ -r "$XDG_CONFIG_HOME/vcsh/config" ] && . "$XDG_CONFIG_HOME/vcsh/config"
67 if [ -n "$VCSH_OPTION_CONFIG" ]; then
68 # Source $VCSH_OPTION_CONFIG if it can be read and is in $PWD of $PATH
69 if [ -r "$VCSH_OPTION_CONFIG" ]; then
70 source_all "$VCSH_OPTION_CONFIG"
72 fatal "Can not read configuration file '$VCSH_OPTION_CONFIG'" 1
75 [ -n "$VCSH_DEBUG" ] && set -vx
78 [ -z "$VCSH_REPO_D" ] && VCSH_REPO_D="$XDG_CONFIG_HOME/vcsh/repo.d"
79 [ -z "$VCSH_HOOK_D" ] && VCSH_HOOK_D="$XDG_CONFIG_HOME/vcsh/hooks-enabled"
80 [ -z "$VCSH_BASE" ] && VCSH_BASE="$HOME"
81 [ -z "$VCSH_GITIGNORE" ] && VCSH_GITIGNORE='exact'
85 echo "usage: $SELF <options> <command>
90 -v Enable verbose mode
94 [<repo>] Clone from an existing repository
95 delete <repo> Delete an existing repository
96 enter <repo> Enter repository; spawn new instance of \$SHELL
97 help Display this help text
98 init <repo> Initialize a new repository
99 list List all repositories
100 list-tracked List all files tracked by vcsh
102 <repo> List files tracked by a repository
104 <newname> Rename repository
106 <command> Use this repository
107 upgrade <repo> Upgrade repository to currently recommended settings
108 version Print version information
109 which <substring> Find substring in name of any tracked file
111 <repo> Write .gitignore.d/<repo> via git ls-files
113 <repo> <git command> Shortcut to run git commands directly
114 <repo> Shortcut to enter repository" >&2
118 [ -n "$VCSH_DEBUG" ] && echo "$SELF: debug: $@"
122 if [ -n "$VCSH_DEBUG" ] || [ -n "$VCSH_VERBOSE" ]; then echo "$SELF: verbose: $@"; fi
126 echo "$SELF: error: $1" >&2
130 echo "$SELF: info: $1"
135 git remote add origin "$GIT_REMOTE"
136 git config branch.master.remote origin
137 git config branch.master.merge refs/heads/master
138 if [ $(git ls-remote origin master 2> /dev/null | wc -l ) -lt 1 ]; then
139 info "remote is empty, not merging anything"
143 for object in $(git ls-tree -r origin/master | awk '{print $4}'); do
145 error "'$object' exists." &&
148 [ "$VCSH_CONFLICT" = '1' ] &&
149 fatal "will stop after fetching and not try to merge!
150 Once this situation has been resolved, run 'vcsh run $VCSH_REPO_NAME git pull' to finish cloning.\n" 17
151 git merge origin/master
155 cd "$VCSH_BASE" || fatal "could not enter '$VCSH_BASE'" 11
157 info "This operation WILL DESTROY DATA!"
158 files=$(git ls-files)
159 echo "These files will be deleted:
163 AGAIN, THIS WILL DELETE YOUR DATA!
164 To continue, type 'Yes, do as I say'"
166 [ "x$answer" = 'xYes, do as I say' ] || exit 16
167 for file in $files; do
168 rm -f $file || info "could not delete '$file', continuing with deletion"
170 rm -rf "$GIT_DIR" || error "could not delete '$GIT_DIR'"
181 [ -d "$GIT_DIR" ] || fatal "no repository found for '$VCSH_REPO_NAME'" 12
185 for hook in $VCSH_HOOK_D/$1* $VCSH_HOOK_D/$VCSH_REPO_NAME.$1*; do
186 [ -x "$hook" ] || continue
187 verbose "executing '$hook'"
193 [ ! -e "$GIT_DIR" ] || fatal "'$GIT_DIR' exists" 10
194 export GIT_WORK_TREE="$VCSH_BASE"
195 mkdir -p "$GIT_WORK_TREE" || fatal "could not create '$GIT_WORK_TREE'" 50
196 cd "$GIT_WORK_TREE" || fatal "could not enter '$GIT_WORK_TREE'" 11
202 for repo in "$VCSH_REPO_D"/*.git; do
203 [ -d "$repo" ] && [ -r "$repo" ] && echo $(basename "$repo" .git)
208 export GIT_DIR="$VCSH_REPO_D/$VCSH_REPO_NAME.git"
213 for VCSH_REPO_NAME in $(list); do
220 git ls-files | sort -u
225 [ -d "$GIT_DIR_NEW" ] && fatal "'$GIT_DIR_NEW' exists" 54
226 mv -f "$GIT_DIR" "$GIT_DIR_NEW" || fatal "Could not mv '$GIT_DIR' '$GIT_DIR_NEW'" 52
240 git config core.worktree "$GIT_WORK_TREE"
241 [ ! "x$VCSH_GITIGNORE" = 'xnone' ] && git config core.excludesfile ".gitignore.d/$VCSH_REPO_NAME"
242 git config vcsh.vcsh 'true'
243 [ -e "$VCSH_BASE/.gitignore.d/$VCSH_REPO_NAME" ] && git add -f "$VCSH_BASE/.gitignore.d/$VCSH_REPO_NAME"
249 export GIT_WORK_TREE="$(git config --get core.worktree)"
250 export VCSH_DIRECTORY="$VCSH_REPO_NAME"
254 for VCSH_REPO_NAME in $(list); do
255 for VCSH_FILE in $(get_files); do
256 echo $VCSH_FILE | grep -q "$VCSH_COMMAND_PARAMETER" && echo "$VCSH_REPO_NAME: $VCSH_FILE"
262 # Don't do anything if the user does not want to write gitignore
263 if [ "x$VCSH_GITIGNORE" = 'xnone' ] then
264 info "Not writing gitignore as '\$VCSH_GITIGNORE' is set to 'none'"
269 cd "$VCSH_BASE" || fatal "could not enter '$VCSH_BASE'" 11
270 gitignores=$(for file in $(git ls-files); do
272 echo $file; new="${file%/*}"
273 [ "$file" = "$new" ] && break
277 tempfile=$(mktemp) || fatal "could not create tempfile" 51
278 echo '*' > "$tempfile" || fatal "could not write to '$tempfile'" 57
279 for gitignore in $gitignores; do
280 echo "$gitignore" | sed 's@^@!/@' >> "$tempfile" || fatal "could not write to '$tempfile'" 57
281 if [ "x$VCSH_GITIGNORE" = 'xrecursive' ] && [ -d "$gitignore" ]; then
282 { echo "$gitignore/*" | sed 's@^@!/@' >> "$tempfile" || fatal "could not write to '$tempfile'" 57; }
285 if diff -N "$tempfile" "$VCSH_BASE/.gitignore.d/$VCSH_REPO_NAME" > /dev/null; then
286 rm -f "$tempfile" || error "could not delete '$tempfile'"
289 if [ -e "$VCSH_BASE/.gitignore.d/$VCSH_REPO_NAME" ]; then
290 info "'$VCSH_BASE/.gitignore.d/$VCSH_REPO_NAME' differs from new data, moving it to '$VCSH_BASE/.gitignore.d/$VCSH_REPO_NAME.bak'"
291 mv -f "$VCSH_BASE/.gitignore.d/$VCSH_REPO_NAME" "$VCSH_BASE/.gitignore.d/$VCSH_REPO_NAME.bak" ||
292 fatal "could not move '$VCSH_BASE/.gitignore.d/$VCSH_REPO_NAME' to '$VCSH_BASE/.gitignore.d/$VCSH_REPO_NAME.bak'" 53
294 mv -f "$tempfile" "$VCSH_BASE/.gitignore.d/$VCSH_REPO_NAME" ||
295 fatal "could not move '$tempfile' to '$VCSH_BASE/.gitignore.d/$VCSH_REPO_NAME'" 53
298 if [ ! "x$VCSH_GITIGNORE" = 'xexact' ] && [ ! "x$VCSH_GITIGNORE" = 'xrecursive' ] && [ ! "x$VCSH_GITIGNORE" = 'xnone' ]; then
299 fatal "'\$VCSH_GITIGNORE' must equal 'exact', 'recursive', or 'none'" 1
302 if [ "$1" = 'clone' ]; then
303 [ -z "$2" ] && fatal "$1: please specify a remote" 1
304 export VCSH_COMMAND="$1"
306 [ -n "$3" ] && VCSH_REPO_NAME="$3" || VCSH_REPO_NAME=$(basename "$GIT_REMOTE" .git)
307 export VCSH_REPO_NAME
308 export GIT_DIR="$VCSH_REPO_D/$VCSH_REPO_NAME.git"
309 elif [ "$1" = 'version' ]; then
310 echo "$SELF $VERSION"
312 elif [ "$1" = 'which' ]; then
313 [ -z "$2" ] && fatal "$1: please specify a filename" 1
314 [ -n "$3" ] && fatal "$1: too many parameters" 1
315 export VCSH_COMMAND="$1"
316 export VCSH_COMMAND_PARAMETER="$2"
317 elif [ "$1" = 'delete' ] ||
318 [ "$1" = 'enter' ] ||
320 [ "$1" = 'list-tracked-by' ] ||
321 [ "$1" = 'rename' ] ||
323 [ "$1" = 'upgrade' ] ||
324 [ "$1" = 'write-gitignore' ]; then
325 [ -z $2 ] && fatal "$1: please specify repository to work on" 1
326 [ "$1" = 'rename' -a -z "$3" ] && fatal "$1: please specify a target name" 1
327 [ "$1" = 'run' -a -z "$3" ] && fatal "$1: please specify a command" 1
328 export VCSH_COMMAND="$1"
329 export VCSH_REPO_NAME="$2"
330 export GIT_DIR="$VCSH_REPO_D/$VCSH_REPO_NAME.git"
331 [ "$VCSH_COMMAND" = 'rename' ] && export GIT_DIR_NEW="$VCSH_REPO_D/$3.git"
332 [ "$VCSH_COMMAND" = 'run' ] && shift 2
333 [ "$VCSH_COMMAND" = 'write-gitignore' ]
334 elif [ "$1" = 'list' ] ||
335 [ "$1" = 'list-tracked' ]; then
336 export VCSH_COMMAND="$1"
337 elif [ -n "$2" ]; then
338 export VCSH_COMMAND='run'
339 export VCSH_REPO_NAME="$1"
340 export GIT_DIR="$VCSH_REPO_D/$VCSH_REPO_NAME.git"
341 [ -d $GIT_DIR ] || { help; exit 1; }
344 elif [ -n "$1" ]; then
345 export VCSH_COMMAND='enter'
346 export VCSH_REPO_NAME="$1"
347 export GIT_DIR="$VCSH_REPO_D/$VCSH_REPO_NAME.git"
348 [ -d $GIT_DIR ] || { help; exit 1; }
350 # $1 is empty, or 'help'
354 # Did we receive a directory instead of a name?
355 # Mangle the input to fit normal operation.
356 if echo $VCSH_REPO_NAME | grep -q '/'; then
357 export GIT_DIR=$VCSH_REPO_NAME
358 export VCSH_REPO_NAME=$(basename "$VCSH_REPO_NAME" .git)
362 for check_directory in "$VCSH_REPO_D" "$VCSH_BASE/.gitignore.d"
364 if [ ! -d "$check_directory" ]; then
365 if [ -e "$check_directory" ]; then
366 fatal "'$check_directory' exists but is not a directory" 13
368 info "attempting to create '$check_directory'"
369 mkdir -p "$check_directory" || fatal "could not create '$check_directory'" 50
374 verbose "$VCSH_COMMAND begin"
375 export VCSH_COMMAND=$(echo $VCSH_COMMAND | sed 's/-/_/g')
379 verbose "$VCSH_COMMAND end, exiting"